diff --git a/Makefile.am b/Makefile.am
index e10be9d..96749ac 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -18,25 +18,15 @@ distuninstallcheck:
                                                                                                                                                              
 distcleancheck_listfiles = find . -type f -print | grep -v 'omf\.out' | grep -v 'legal.xml'
 
-if BUILD_GFLOPPY
-gfloppy = gfloppy
-endif
-
 always_built_SUBDIRS =   \
 	po 		 \
-	logview 	 \
-	gsearchtool	 \
-	gnome-dictionary \
-	gnome-screenshot \
-	baobab
+	logview
 
 SUBDIRS = \
-	$(always_built_SUBDIRS)	\
-	$(gfloppy)
+	$(always_built_SUBDIRS)
 
 DIST_SUBDIRS = \
-	$(always_built_SUBDIRS)	\
-	gfloppy
+	$(always_built_SUBDIRS)
 
 EXTRA_DIST = \
 	gnome-utils.spec.in \
diff --git a/configure.ac b/configure.ac
index 70547af..f9bc205 100644
--- a/configure.ac
+++ b/configure.ac
@@ -85,6 +85,7 @@ GNOMEVFS_REQUIRED=2.8.4
 LIBPANEL_APPLET_REQUIRED=2.13.4
 LIBGTOP_REQUIRED=2.12.0
 GNOMECANVAS_REQUIRED=2.10.2
+GMODULE_REQUIRED=2.10.2
 
 dnl *****************************************
 dnl libgnome, libgnomeui needed for all utils
@@ -149,29 +150,6 @@ PKG_CHECK_MODULES(SCREENSHOT, gio-2.0 >= $GLIB_REQUIRED dnl
 AC_SUBST(SCREENSHOT_CFLAGS)
 AC_SUBST(SCREENSHOT_LIBS)
 
-dnl ****************************************
-dnl HAL for floppy detection in gfloppy
-dnl ****************************************
-AC_ARG_ENABLE(hal,
-              AC_HELP_STRING([--enable-hal], [use HAL if available]), [
-              case "${enableval}" in
-                yes) ENABLE_HAL=yes ;;
-                no)  ENABLE_HAL=no ;;
-                *) AC_MSG_ERROR(bad value ${enableval} for --enable-hal) ;;
-              esac],
-              [ENABLE_HAL=yes]) dnl Default value
-
-if test "x$ENABLE_HAL" = "xyes"; then
-	PKG_CHECK_MODULES(HAL, hal >= 0.5.0,
-		AC_DEFINE(USE_HAL, 1, [defined if using libhal]),
-		[ USE_HAL=""])
-else
-	USE_HAL=""
-fi
-
-AC_SUBST(HAL_CFLAGS)
-AC_SUBST(HAL_LIBS)
-
 dnl *********************************************
 dnl gnome-vfs/mime-data is need for gsearchtool
 dnl *********************************************
@@ -424,6 +402,9 @@ AC_SUBST(GREP_COMMAND)
 dnl ********************
 dnl logview checks
 dnl ********************
+PKG_CHECK_MODULES(GMODULE, gmodule-2.0 >= $GMODULE_REQUIRED)
+AC_SUBST(GMODULE_CFLAGS)
+AC_SUBST(GMODULE_LIBS)
 
 dnl This is where the binary actually resides,
 dnl not the console helper link
@@ -434,7 +415,8 @@ else
 fi
 EXPANDED_LOGVIEWDIR=`eval echo $LOGVIEWDIR_TMP`
 AC_SUBST(EXPANDED_LOGVIEWDIR)
-
+PLUGIN_LIBTOOL_FLAGS="-module -avoid-version"
+AC_SUBST(PLUGIN_LIBTOOL_FLAGS)
 
 dnl ********************
 dnl scrollkeeper checks 
@@ -469,34 +451,13 @@ AC_OUTPUT([
 Makefile
 gnome-utils.spec
 po/Makefile.in
-baobab/Makefile
-baobab/data/Makefile
-baobab/pixmaps/Makefile
-baobab/pixmaps/24x24/Makefile
-baobab/pixmaps/scalable/Makefile
-baobab/src/Makefile
-baobab/help/Makefile
 logview/Makefile
 logview/gnome-system-log-security
 logview/help/Makefile
-gsearchtool/Makefile
-gsearchtool/data/Makefile
-gsearchtool/help/Makefile
-gnome-dictionary/Makefile
-gnome-dictionary/libgdict/Makefile
-gnome-dictionary/libgdict/gdict-version.h
-gnome-dictionary/libgdict/gdict-1.0.pc
-gnome-dictionary/data/Makefile
-gnome-dictionary/docs/Makefile
-gnome-dictionary/docs/reference/Makefile
-gnome-dictionary/docs/reference/gdict/Makefile
-gnome-dictionary/docs/reference/gdict/version.xml
-gnome-dictionary/help/Makefile
-gnome-dictionary/src/Makefile
-gfloppy/Makefile
-gfloppy/doc/Makefile
-gfloppy/src/Makefile
-gnome-screenshot/Makefile
+logview/plugins/Makefile
+logview/docs/Makefile
+logview/docs/reference/Makefile
+logview/docs/reference/logview/Makefile
 ])
 
 dnl <= Configuration summary =>
diff --git a/logview/Makefile.am b/logview/Makefile.am
index d693568..e4a6706 100644
--- a/logview/Makefile.am
+++ b/logview/Makefile.am
@@ -1,6 +1,17 @@
 # Process this file with automake to produce Makefile.in
 
-SUBDIRS = help
+SUBDIRS = . plugins help docs 
+
+gnome_system_log_includedir = $(includedir)/gnome-system-log
+gnome_system_log_include_HEADERS = \
+	logview-log.h		\
+	logview-plugin.h	\
+	logview-iface.h		\
+	logview-iface-io.h	\
+	logview-iface-collector.h	\
+	logview-iface-view.h	\
+	logview-debug.h		\
+	$(NULL)
 
 Utilitiesdir = $(datadir)/applications
 additionaldir  = $(datadir)/gnome-system-log
@@ -10,7 +21,8 @@ INCLUDES = \
 	-DG_LOG_DOMAIN=\"gnome-system-log\"			\
 	-DGNOMELOCALEDIR=\""$(prefix)/$(DATADIRNAME)/locale"\"	\
 	-DDATADIR=\""$(datadir)"\"				\
-	-DLOGVIEWINSTALLPREFIX=\""$(prefix)/\""			\
+	-DLOGVIEWINSTALLPREFIX=\""$(prefix)/"\"			\
+	-DLOGVIEWPLUGINDIR=\""$(libdir)/gnome-system-log/plugins"\"	\
 	$(SUN_OS)						\
 	$(NULL)
 
@@ -24,12 +36,8 @@ gnome_system_log_SOURCES = 	\
 	calendar.h		\
 	log_repaint.c		\
 	log_repaint.h		\
-	logrtns.c		\
-	logrtns.h		\
 	logview.c		\
 	logview.h		\
-	misc.c			\
-	misc.h			\
 	monitor.c       	\
 	monitor.h		\
 	userprefs.c             \
@@ -37,12 +45,44 @@ gnome_system_log_SOURCES = 	\
 	logview-findbar.c	\
 	logview-findbar.h   \
 	loglist.c       \
-	loglist.h
+	loglist.h	\
+	logview-module.c	\
+	logview-module.h	\
+	logview-plugin-list.c	\
+	logview-plugin-list.h	\
+	logview-plugin.c		\
+	logview-plugin.h		\
+	logview-plugin-manager.c	\
+	logview-plugin-manager.h	\
+	$(NULL)
 
 gnome_system_log_LDADD = \
-	$(GNOME_UTILS_LIBS)
+	$(GNOME_UTILS_LIBS)	\
+	$(GMODULE_LIBS)		\
+	libgnome-system-log.la
 
-man_MANS = gnome-system-log.1
+noinst_LTLIBRARIES = libgnome-system-log.la
+libgnome_system_log_la_SOURCES = \
+	logrtns.c		\
+	logrtns.h		\
+	misc.c			\
+	misc.h			\
+	logview-iface.c		\
+	logview-iface.h		\
+	logview-iface-io.c		\
+	logview-iface-io.h		\
+	logview-iface-collector.c	\
+	logview-iface-collector.h	\
+	logview-iface-view.c	\
+	logview-iface-view.h	\
+	logview-debug.c			\
+	logview-debug.h			\
+	logview-log.h		\
+	$(NULL)
+
+libgnome_system_log_la_LIBADD = \
+	$(GNOME_UTILS_LIBS)	\
+	$(GMODULE_LIBS)
 
 Utilities_in_files = gnome-system-log.desktop.in
 Utilities_DATA = $(Utilities_in_files:.desktop.in=.desktop)
@@ -98,3 +138,4 @@ CLEANFILES = 				\
 dist-hook:
 	cd $(distdir) ; rm -f $(CLEANFILES)
 
+
diff --git a/logview/calendar.c b/logview/calendar.c
index b6ad451..b20cd5c 100644
--- a/logview/calendar.c
+++ b/logview/calendar.c
@@ -64,7 +64,7 @@ calendar_init_data (Calendar *calendar, LogviewWindow *logview)
     g_return_if_fail (IS_CALENDAR (calendar));
 	g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
 
-	g_object_get (G_OBJECT (logview), "days", &(calendar->priv->days), NULL);
+	g_object_get (G_OBJECT (logview->curlog), "days", &(calendar->priv->days), NULL);
     calendar->priv->first_pass = TRUE;
 
     calendar_mark_dates (calendar);
@@ -77,23 +77,6 @@ calendar_month_changed (GtkWidget *widget, gpointer data)
     calendar_mark_dates (CALENDAR (widget));
 }
 
-static Day *
-log_find_day (Log *log, int d, int m, int y)
-{
-    GDate *date;
-    GSList *days;
-    Day *day, *found_day = NULL;
-    
-    date = g_date_new_dmy (d, m+1, y);
-    for (days = log->days; days!=NULL; days=g_slist_next(days)) {
-        day = days->data;
-        if (g_date_compare (day->date, date) == 0) {
-            found_day = day;
-        }
-    }
-    return found_day;
-}
-
 static void
 calendar_day_selected (GtkWidget *widget, LogviewWindow *logview)
 {
@@ -101,6 +84,9 @@ calendar_day_selected (GtkWidget *widget, LogviewWindow *logview)
     guint day, month, year;
     Day *found_day;
     GtkTreePath *path;
+    GList *selected_paths;
+    GtkTreePath *select_first;
+    GDate *date;    
 
     calendar = CALENDAR (widget);
 
@@ -113,11 +99,20 @@ calendar_day_selected (GtkWidget *widget, LogviewWindow *logview)
     }
   
     gtk_calendar_get_date (GTK_CALENDAR (calendar), &year, &month, &day);    
-    found_day = log_find_day (logview->curlog, day, month, year);
+
+    date = g_date_new_dmy (day, month+1, year);
+    found_day = log_find_day (logview->curlog, date);
+    g_date_free (date);
+
+    g_object_get (G_OBJECT (logview->curlog),
+		  "selected-paths", &selected_paths,
+		  NULL);
+    g_assert (selected_paths);
+    select_first = g_list_first (selected_paths)->data;
     if (found_day != NULL) {
         path = found_day->path;
-        if ((gtk_tree_path_compare (path, logview->curlog->selected_range.first) != 0) &&
-            (!gtk_tree_path_is_descendant (logview->curlog->selected_range.first, path)))
+        if ((gtk_tree_path_compare (path, select_first) != 0) &&
+            (!gtk_tree_path_is_descendant (select_first, path)))
             gtk_tree_view_set_cursor (GTK_TREE_VIEW(logview->view), path, NULL, FALSE);
     }
 }
diff --git a/logview/docs/Makefile.am b/logview/docs/Makefile.am
new file mode 100644
index 0000000..86bb4ad
--- /dev/null
+++ b/logview/docs/Makefile.am
@@ -0,0 +1,3 @@
+# Process this file with automake to produce Makefile.in
+
+SUBDIRS = reference
diff --git a/logview/docs/reference/Makefile.am b/logview/docs/reference/Makefile.am
new file mode 100644
index 0000000..048bd8f
--- /dev/null
+++ b/logview/docs/reference/Makefile.am
@@ -0,0 +1,3 @@
+# Process this file with automake to produce Makefile.in
+
+SUBDIRS = logview
diff --git a/logview/docs/reference/logview/Makefile.am b/logview/docs/reference/logview/Makefile.am
new file mode 100644
index 0000000..ee2c82a
--- /dev/null
+++ b/logview/docs/reference/logview/Makefile.am
@@ -0,0 +1,84 @@
+## Process this file with automake to produce Makefile.in
+
+AUTOMAKE_OPTIONS = 1.6
+
+# The name of the module, e.g. 'glib'.
+DOC_MODULE=logview
+
+# The top-level SGML file. Change it if you want.
+DOC_MAIN_SGML_FILE=$(DOC_MODULE)-docs.sgml
+
+# The directory containing the source code. Relative to $(srcdir).
+# gtk-doc will search all .c & .h files beneath here for inline comments
+# documenting functions and macros.
+DOC_SOURCE_DIR=$(top_srcdir)/logview
+
+# Extra options to supply to gtkdoc-scan.
+SCAN_OPTIONS=
+
+# Extra options to pass to gtkdoc-scangobj
+SCANGOBJ_OPTIONS=
+
+# Extra options to supply to gtkdoc-mkdb.
+MKDB_OPTIONS=--sgml-mode --output-format=xml
+
+# Extra options to supply to gtkdoc-mktmpl
+# e.g. MKTMPL_OPTIONS=--only-section-tmpl
+MKTMPL_OPTIONS=
+
+# Extra options to supply to gtkdoc-fixref.
+FIXXREF_OPTIONS=
+
+# Used for dependencies.
+HFILE_GLOB=$(top_srcdir)/logview/*.h
+CFILE_GLOB=$(top_srcdir)/logview/*.c
+
+# Header files to ignore when scanning.
+IGNORE_HFILES =			\
+	about.h			\
+	calendar.h		\
+	log_repaint.h		\
+	logview.h		\
+	monitor.h		\
+	userprefs.h		\
+	logview-findbar.h	\
+	loglist.h		\
+	logview-module.h	\
+	logview-plugin.h	\
+	logview-plugin-manager.h	\
+	logview-plugin-list.h
+
+# Images to copy into HTML directory.
+HTML_IMAGES =
+
+# Extra SGML files that are included by $(DOC_MAIN_SGML_FILE).
+content_files =
+
+# SGML files where gtk-doc abbrevations (#GtkWidget) are expanded
+# These files must be listed here *and* in content_files
+# e.g. expand_content_files=running.sgml
+expand_content_files=
+
+# CFLAGS and LDFLAGS for compiling gtkdoc-scangobj with your library.
+# Only needed if you are using gtkdoc-scangobj to dynamically query widget
+# signals and properties.
+# e.g. INCLUDES=-I$(top_srcdir) -I$(top_builddir) $(GTK_DEBUG_FLAGS)
+# e.g. GTKDOC_LIBS=$(top_builddir)/gtk/$(gtktargetlib)
+INCLUDES=				\
+	$(CFLAGS)			\
+	$(CPPFLAGS)			\
+	$(GNOME_UTILS_CFLAGS)		\
+	-I$(top_srcdir)/logview		\
+	-I$(top_builddir)/logview
+
+GTKDOC_LIBS=			\
+	$(LDFLAGS)		\
+	$(GNOME_UTILS_LIBS)	\
+	$(top_builddir)/logview/libgnome-system-log.la
+
+# This includes the standard gtk-doc make rules, copied by gtkdocize.
+include $(top_srcdir)/gtk-doc.make
+
+# Other files to distribute
+# e.g. EXTRA_DIST += version.xml.in
+EXTRA_DIST +=
diff --git a/logview/docs/reference/logview/logview-docs.sgml b/logview/docs/reference/logview/logview-docs.sgml
new file mode 100644
index 0000000..e6dc9be
--- /dev/null
+++ b/logview/docs/reference/logview/logview-docs.sgml
@@ -0,0 +1,44 @@
+<?xml version="1.0" standalone="no"?>
+<!DOCTYPE article PUBLIC "-//OASIS//DTD DocBook XML V4.1.2//EN"
+    "http://www.oasis-open.org/docbook/xml/4.1.2/docbookx.dtd" [
+<!ENTITY index-Object-Tree SYSTEM "xml/tree_index.sgml">
+<!ENTITY LogviewLog SYSTEM "xml/logview-log.xml">
+<!ENTITY LogviewPlugin SYSTEM "xml/logview-plugin.xml">
+<!ENTITY LogviewIface SYSTEM "xml/logview-iface.xml">
+<!ENTITY LogviewIfaceIO SYSTEM "xml/logview-iface-io.xml">
+<!ENTITY LogviewIfaceView SYSTEM "xml/logview-iface-view.xml">
+<!ENTITY LogviewIfaceCollector SYSTEM "xml/logview-iface-collector.xml">
+<!ENTITY LogviewMisc SYSTEM "xml/misc.xml">
+]>
+
+<book id="logview">
+  <bookinfo>
+    <title>GNOME System Log Plugin Interfaces Reference Manual</title>
+    <abstract>
+      <para>This manual documents the Gnome System Log Plugin Interfaces.</para>
+    </abstract>
+  </bookinfo>
+  
+  <preface>
+    <title>Introduction</title>
+    <para>The Gnome System Log Plugin Interfaces enable endusers to implement
+    plugins to display non-ASCII formatted log files.</para>
+    <para>It was created for the GNOME System Log application, but it has been
+    made available for each developer whom wishes to implement plugins for
+    fun.</para>
+  </preface>
+  
+  <reference label="I">
+    <title>API reference</title>
+    &LogviewLog;
+    &LogviewIface;
+    &LogviewIfaceIO;
+    &LogviewIfaceView;
+    &LogviewIfaceCollector;
+  </reference>
+
+  <reference label="II">
+    <title>Miscellaneous Utility Functions</title>
+    &LogviewMisc;
+  </reference>
+</book>
diff --git a/logview/docs/reference/logview/logview.types b/logview/docs/reference/logview/logview.types
new file mode 100644
index 0000000..a303ce1
--- /dev/null
+++ b/logview/docs/reference/logview/logview.types
@@ -0,0 +1,5 @@
+logview_iface_collector_get_type
+logview_iface_view_get_type
+logview_iface_io_get_type
+logview_iface_get_type
+log_get_type
diff --git a/logview/gnome-system-log.desktop.in.in b/logview/gnome-system-log.desktop.in.in
index a06ba81..5a2be33 100644
--- a/logview/gnome-system-log.desktop.in.in
+++ b/logview/gnome-system-log.desktop.in.in
@@ -7,6 +7,7 @@ Terminal=false
 Type=Application
 StartupNotify=true
 Categories=GTK;GNOME;System;Monitor;
+OnlyShowIn=GNOME;
 NotShowIn=KDE;
 X-GNOME-DocPath=gnome-system-log/gnome-system-log.xml
 X-GNOME-Bugzilla-Bugzilla=GNOME
